import Vue from 'vue'

const STATUS = {
  // 订单
  orderStatus: {
    "0": "待支付:red",
    "1": "待发货:red",
    "2": "已发货:green",
    "3": "已完成:blue",
    "4": "未支付:gray",
    "5": "已评论:gray",
    "6": "已支付但暂不可发货:yellow",
  },
  // 寄售订单
  marketStatus: {
    "0": "待支付:red",
    "1": "待发货:red",
    "2": "已发货:green",
    "3": "已完成:blue",
    "4": "已关闭:gray",
  },
  // 订单
  givingStatus: {
    "00": "接收中:yellow",
    "01": "接收中:yellow",
    "10": "转赠中:blue",
    "11": "转赠中:blue",
    "0-1": "接收失败:red",
    "1-1": "转赠失败:red",
    "02": "接收完成:green",
    "12": "转赠完成:green"
  },
  // 账单订单
  billStatus: {
    "0": "充值",
    "1": "提现",
    "2": "寄售成功",
    "3": "购买成功",
  },
}

for (let key in STATUS) {
  Vue.filter(key, (value, color = true) => {
    let text = STATUS[key][value];
    if (color) {
      if (color == 'no') {
        return text
      } else {
        return text || '未知状态:gray';
      }
    } else {
      return text ? text.replace(/:.*/g, '') : '全部';
    }
  })
}
